/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.39 Revision 1.59
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.39 2006/10/20 14:44:01 chtekk Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.59 2007/01/05 00:07:23 vivo Exp $
4# kate: encoding utf-8; eol unix;
5# kate: indent-width 4; mixedindent off; remove-trailing-space on; space-indent off;
6# kate: word-wrap-column 80; word-wrap off;
4 7
5# Author: Francesco Riosa <vivo@gentoo.org> 8# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
6# Maintainer: Luca Longinotti <chtekk@gentoo.org> 9# Maintainer: Luca Longinotti <chtekk@gentoo.org>
7 10
8# Both MYSQL_VERSION_ID and MYSQL_PATCHSET_REV must be set in the ebuild too
9# Note that MYSQL_VERSION_ID must be empty !!! 11# Note that MYSQL_VERSION_ID must be empty !!!
10 12
13ECLASS="mysql"
14INHERITED="$INHERITED $ECLASS"
15WANT_AUTOCONF="latest"
16WANT_AUTOMAKE="latest"
17inherit eutils flag-o-matic gnuconfig autotools mysql_fx
18
19# Shorten the path because the socket path length must be shorter than 107 chars
20# and we will run a mysql server during test phase
21S="${WORKDIR}/mysql"
22
23# avoid running userspace code 8 times per ebuild :(
24if [[ "${_MYPVR}" != "${PVR}" ]] && [[ -n "${PVR}" ]]
25then
26 _MYPVR=${PVR}
27
28 [[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070105"
29
30 if [[ ${PR#r} -lt 60 ]] ; then
31 IS_BITKEEPER=0
32 elif [[ ${PR#r} -lt 90 ]] ; then
33 IS_BITKEEPER=60
34 else
35 IS_BITKEEPER=90
36 fi
37
11# MYSQL_VERSION_ID will be: 38 # MYSQL_VERSION_ID will be:
12# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 39 # major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
13# This is an important part, because many of the choices the MySQL ebuild will do 40 # This is an important part, because many of the choices the MySQL ebuild will do
14# depend on this variable. 41 # depend on this variable.
15# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803" 42 # In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
16 43 MYSQL_VERSION_ID=""
17if [[ -z "${MYSQL_VERSION_ID}" ]] ; then
18 tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}" 44 tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}"
19 for vatom in 0 1 2 3 ; do 45 for vatom in 0 1 2 3 ; do
20 # pad to length 2 46 # pad to length 2
21 tpv[${vatom}]="00${tpv[${vatom}]}" 47 tpv[${vatom}]="00${tpv[${vatom}]}"
22 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}" 48 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}"
23 done 49 done
24 # strip leading "0" (otherwise it's considered an octal number by BASH) 50 # strip leading "0" (otherwise it's considered an octal number by BASH)
25 MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"} 51 MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
26fi
27 52
28DEPEND="${DEPEND} 53 # Be warned, *DEPEND are version-dependant
29 >=sys-libs/readline-4.1
30 berkdb? ( sys-apps/ed )
31 ssl? ( >=dev-libs/openssl-0.9.6d ) 54 DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d )
32 userland_GNU? ( sys-process/procps ) 55 userland_GNU? ( sys-process/procps )
33 >=sys-libs/zlib-1.2.3 56 >=sys-apps/sed-4
34 >=sys-apps/texinfo-4.7-r1 57 >=sys-apps/texinfo-4.7-r1
35 >=sys-apps/sed-4" 58 >=sys-libs/readline-4.1
59 >=sys-libs/zlib-1.2.3
60 "
36 61
37RDEPEND="${DEPEND} selinux? ( sec-policy/selinux-mysql )" 62 # having different flavours at the same time is not a good idea
63 for i in "" "-community" "-slotted" ; do
64 [[ "${i}" == ${PN#mysql} ]] ||
65 DEPEND="${DEPEND} !dev-db/mysql${i}"
66 done
38 67
68 mysql_version_is_at_least "5.1" \
69 || DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
70
39# dev-perl/DBD-mysql is needed by some scripts installed by MySQL 71 # dev-perl/DBD-mysql is needed by some scripts installed by MySQL
40PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 72 PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
41 73
42inherit eutils flag-o-matic gnuconfig autotools mysql_fx 74 if mysql_version_is_at_least "5.1.12" ; then
75 DEPEND="${DEPEND} innodb? ( >=dev-util/cmake-2.4.3 )"
76 fi
43 77
44# Shorten the path because the socket path length must be shorter than 107 chars 78 # BitKeeper dependency, compile-time only
45# and we will run a mysql server during test phase 79 [[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client"
46S="${WORKDIR}/${PN}"
47 80
48# Define $MY_FIXED_PV for MySQL patchsets 81 if [[ ${PN} == "mysql-slotted" ]] ; then
49MY_FIXED_PV="${PV/_alpha/}" 82 DEPEND="${DEPEND} app-admin/eselect-mysql"
50#MY_FIXED_PV="${MY_FIXED_PV/_beta/}" 83 fi
51#MY_FIXED_PV="${MY_FIXED_PV/_rc/}"
52 84
53MY_P="${P/_/-}" 85 if [[ ${PN} == "mysql-slotted" ]] ; then
86 SLOT=""
87 tpv=( ${PV//[-._]/ } )
88 for vatom in 0 1 2 ; do
89 SLOT="${SLOT}${tpv[${vatom}]}_"
90 done
91 #finally SLOT=5_0_24
92 SLOT=${SLOT:0:${#SLOT}-1}
93 else
94 SLOT="0"
95 fi
54 96
55# Define correct SRC_URIs 97 # Define correct SRC_URIs
56SRC_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/${MY_P}${MYSQL_RERELEASE}.tar.gz" 98 SRC_URI="
57if [[ -n "${MYSQL_PATCHSET_REV}" ]] ; then 99 ${SERVER_URI}
58 MYSQL_PATCHSET_FILENAME="${PN}-patchset-${MY_FIXED_PV}-r${MYSQL_PATCHSET_REV}.tar.bz2" 100 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
59 # We add the Gentoo mirror here, as we only use primaryuri for the MySQL tarball 101 "
60 SRC_URI="${SRC_URI} http://gentoo.longitekk.com/${MYSQL_PATCHSET_FILENAME}" 102 mysql_version_is_at_least "5.1.12" \
61fi 103 && [[ -n "${PBXT_VERSION}" ]] \
104 && SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )"
62 105
63DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 106 DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
64HOMEPAGE="http://www.mysql.com/" 107 HOMEPAGE="http://www.mysql.com/"
65SLOT="0"
66LICENSE="GPL-2" 108 LICENSE="GPL-2"
67IUSE="big-tables debug embedded minimal perl selinux srvdir ssl static" 109 IUSE="big-tables debug embedded minimal perl selinux ssl static"
68RESTRICT="confcache" 110 RESTRICT="confcache"
69 111
70mysql_version_is_at_least "4.01.00.00" \ 112 mysql_version_is_at_least "4.1" \
71&& IUSE="${IUSE} latin1" 113 && IUSE="${IUSE} latin1"
72 114
73mysql_version_is_at_least "4.01.03.00" \ 115 mysql_version_is_at_least "4.1.3" \
74&& IUSE="${IUSE} cluster extraengine" 116 && IUSE="${IUSE} cluster extraengine"
75 117
76mysql_version_is_at_least "5.00.00.00" \ 118 mysql_version_is_at_least "5.0" \
77|| IUSE="${IUSE} raid" 119 || IUSE="${IUSE} raid"
78 120
79mysql_version_is_at_least "5.00.18.00" \ 121 mysql_version_is_at_least "5.0.18" \
80&& IUSE="${IUSE} max-idx-128" 122 && IUSE="${IUSE} max-idx-128"
81 123
82mysql_version_is_at_least "5.01.00.00" \ 124 mysql_version_is_at_least "5.1" \
83&& IUSE="${IUSE} innodb" 125 && IUSE="${IUSE} innodb"
84 126
85mysql_version_is_at_least "5.01.00.00" \ 127 mysql_version_is_at_least "5.1" \
86|| IUSE="${IUSE} berkdb" 128 || IUSE="${IUSE} berkdb"
129
130 mysql_version_is_at_least "5.1.12" \
131 && IUSE="${IUSE} pbxt"
132
133 RDEPEND="${DEPEND}
134 sys-apps/mysql
135 selinux? ( sec-policy/selinux-mysql )
136 "
137
138fi # if [[ "${_MYPVR}" != "${PVR}" ]]
87 139
88EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \ 140EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \
89 pkg_postinst pkg_config pkg_postrm 141 pkg_postinst pkg_config pkg_postrm
90 142
91# 143#
92# HELPER FUNCTIONS: 144# HELPER FUNCTIONS:
93# 145#
146
147bitkeeper_fetch() {
148
149 local reposuf
150 if [[ -z "${1}" ]] ; then
151 local tpv
152 tpv=( ${PV//[-._]/ } )
153 reposuf="mysql-${tpv[0]}.${tpv[1]}"
154 else
155 reposuf="${1}"
156 fi
157 einfo "using \"${reposuf}\" repository."
158 local repo_uri="bk://mysql.bkbits.net/${reposuf}"
159 ## -- ebk_store_dir: bitkeeper sources store directory
160 local ebk_store_dir="${PORTAGE_ACTUAL_DISTDIR-${DISTDIR}}/bk-src"
161 ## -- ebk_fetch_cmd: bitkeeper fetch command
162 # always fetch the latest revision, use -r<revision> if a specified revision is wanted
163 # hint: does not work
164 local ebk_fetch_cmd="sfioball"
165 ## -- ebk_update_cmd: bitkeeper update command
166 local ebk_update_cmd="update"
167
168 #addread "/etc/bitkeeper"
169 addwrite "${ebk_store_dir}"
170
171 if [[ ! -d "${ebk_store_dir}" ]]; then
172 debug-print "${FUNCNAME}: initial checkout. creating bitkeeper directory"
173 mkdir -p "${ebk_store_dir}" || die "${EBK}: can't mkdir ${ebk_store_dir}."
174 fi
175
176 pushd "${ebk_store_dir}" || die "${EBK}: can't chdir to ${ebk_store_dir}"
177
178 local wc_path=${reposuf}
179
180 if [[ ! -d "${wc_path}" ]]; then
181 local options="-r+"
182 # first check out
183 einfo "bitkeeper check out start -->"
184 einfo " repository: ${repo_uri}"
185 ${ebk_fetch_cmd} ${options} "${repo_uri}" ${wc_path} \
186 || die "${EBK}: can't fetch from ${repo_uri}."
187 else
188 if [[ ! -d "${wc_path}/BK" ]]; then
189 popd
190 die "Look like ${wc_path} is not a bitkeeper path."
191 fi
192
193 # update working copy
194 einfo "bitkeeper update start -->"
195 einfo " repository: ${repo_uri}"
196
197 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \
198 || die "BK: can't update from ${repo_uri} to ${wc_path}."
199 fi
200
201 einfo " working copy: ${wc_path}"
202 cd "${wc_path}"
203 rsync -rlpgo --exclude="BK/" . "${S}" || die "BK: can't export to ${S}."
204
205 echo
206 popd
207
208}
209
210mysql_disable_test() {
211 local testname="${1}" ; shift
212 local reason="${@}"
213 local mysql_disable_file="${S}/mysql-test/t/disabled.def"
214 echo ${testname} : ${reason} >> "${mysql_disable_file}"
215 ewarn "test \"${testname}\" disabled because: \"${reason}\""
216}
94 217
95# void mysql_init_vars() 218# void mysql_init_vars()
96# 219#
97# Initialize global variables 220# Initialize global variables
98# 2005-11-19 <vivo@gentoo.org> 221# 2005-11-19 <vivo@gentoo.org>
99 222
100mysql_init_vars() { 223mysql_init_vars() {
224 if [[ ${SLOT} == "0" ]] ; then
225 MY_SUFFIX=""
226 else
227 MY_SUFFIX=${MY_SUFFIX:-"-${SLOT}"}
228 fi
101 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR="/usr/share/mysql"} 229 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR:-"/usr/share/mysql${MY_SUFFIX}"}
102 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql"} 230 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql${MY_SUFFIX}"}
103 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"} 231 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql${MY_SUFFIX}"}
104 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"} 232 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql${MY_SUFFIX}"}
105 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql"} 233 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql${MY_SUFFIX}"}
106 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql"} 234 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql${MY_SUFFIX}"}
107 235
108 if [[ -z "${DATADIR}" ]] ; then 236 if [[ -z "${DATADIR}" ]] ; then
109 DATADIR="" 237 DATADIR=""
110 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then 238 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then
111 DATADIR=`"my_print_defaults" mysqld 2>/dev/null \ 239 DATADIR=`"my_print_defaults${MY_SUFFIX}" mysqld 2>/dev/null \
112 | sed -ne '/datadir/s|^--datadir=||p' \ 240 | sed -ne '/datadir/s|^--datadir=||p' \
113 | tail -n1` 241 | tail -n1`
114 if [[ -z "${DATADIR}" ]] ; then 242 if [[ -z "${DATADIR}" ]] ; then
115 if useq "srvdir" ; then
116 DATADIR="${ROOT}/srv/localhost/mysql/datadir"
117 else
118 DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \ 243 DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \
119 | sed -e 's/.*=\s*//'` 244 | sed -e 's/.*=\s*//'`
120 fi
121 fi 245 fi
122 fi 246 fi
123 if [[ -z "${DATADIR}" ]] ; then 247 if [[ -z "${DATADIR}" ]] ; then
124 if useq "srvdir" ; then
125 DATADIR="${ROOT}/srv/localhost/mysql/datadir"
126 else
127 DATADIR="${MY_LOCALSTATEDIR}" 248 DATADIR="${MY_LOCALSTATEDIR}"
128 fi
129 einfo "Using default DATADIR" 249 einfo "Using default DATADIR"
130 fi 250 fi
131 elog "MySQL DATADIR is ${DATADIR}" 251 elog "MySQL DATADIR is ${DATADIR}"
132 252
133 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then 253 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then
140 fi 260 fi
141 export PREVIOUS_DATADIR 261 export PREVIOUS_DATADIR
142 fi 262 fi
143 fi 263 fi
144 264
265 MY_SOURCEDIR=${SERVER_URI##*/}
266 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
267
145 export MY_SHAREDSTATEDIR MY_SYSCONFDIR 268 export MY_SUFFIX MY_SHAREDSTATEDIR MY_SYSCONFDIR
146 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 269 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
147 export MY_INCLUDEDIR 270 export MY_INCLUDEDIR DATADIR MY_SOURCEDIR
148 export DATADIR
149} 271}
150 272
151configure_minimal() { 273configure_minimal() {
152 # These are things we exclude from a minimal build, please 274 # These are things we exclude from a minimal build, please
153 # note that the server actually does get built and installed, 275 # note that the server actually does get built and installed,
154 # but we then delete it before packaging. 276 # but we then delete it before packaging.
155 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication" 277 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication"
156 278
157 for i in ${minimal_exclude_list} ; do 279 for i in ${minimal_exclude_list} ; do
158 myconf="${myconf} --without-${i}" 280 myconf="${myconf} --without-${i}"
159 done 281 done
160 myconf="${myconf} --with-extra-charsets=none" 282 myconf="${myconf} --with-extra-charsets=none"
283 myconf="${myconf} --enable-local-infile"
284
285 if useq "static" ; then
286 myconf="${myconf} --with-client-ldflags=-all-static"
287 myconf="${myconf} --disable-shared"
288 else
289 myconf="${myconf} --enable-shared --enable-static"
290 fi
291
292 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then
293 myconf="${myconf} --with-charset=utf8"
294 myconf="${myconf} --with-collation=utf8_general_ci"
295 else
296 myconf="${myconf} --with-charset=latin1"
297 myconf="${myconf} --with-collation=latin1_swedish_ci"
298 fi
161} 299}
162 300
163configure_common() { 301configure_common() {
164 myconf="${myconf} $(use_with big-tables)" 302 myconf="${myconf} $(use_with big-tables)"
165 myconf="${myconf} --enable-local-infile" 303 myconf="${myconf} --enable-local-infile"
166 myconf="${myconf} --with-extra-charsets=all" 304 myconf="${myconf} --with-extra-charsets=all"
167 myconf="${myconf} --with-mysqld-user=mysql" 305 myconf="${myconf} --with-mysqld-user=mysql"
168 myconf="${myconf} --with-server" 306 myconf="${myconf} --with-server"
169 myconf="${myconf} --with-unix-socket-path='/var/run/mysqld/mysqld.sock'" 307 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock"
170 myconf="${myconf} --without-libwrap" 308 myconf="${myconf} --without-libwrap"
171 309
172 if useq "static" ; then 310 if useq "static" ; then
173 myconf="${myconf} --with-mysqld-ldflags=-all-static" 311 myconf="${myconf} --with-mysqld-ldflags=-all-static"
174 myconf="${myconf} --with-client-ldflags=-all-static" 312 myconf="${myconf} --with-client-ldflags=-all-static"
179 317
180 if useq "debug" ; then 318 if useq "debug" ; then
181 myconf="${myconf} --with-debug=full" 319 myconf="${myconf} --with-debug=full"
182 else 320 else
183 myconf="${myconf} --without-debug" 321 myconf="${myconf} --without-debug"
184 mysql_version_is_at_least "4.01.03.00" \ 322 mysql_version_is_at_least "4.1.3" \
185 && useq "cluster" \ 323 && useq "cluster" \
186 && myconf="${myconf} --without-ndb-debug" 324 && myconf="${myconf} --without-ndb-debug"
187 fi 325 fi
188 326
189 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then 327 if mysql_version_is_at_least "4.1" && ! useq "latin1" ; then
190 myconf="${myconf} --with-charset=utf8" 328 myconf="${myconf} --with-charset=utf8"
191 myconf="${myconf} --with-collation=utf8_general_ci" 329 myconf="${myconf} --with-collation=utf8_general_ci"
192 else 330 else
193 myconf="${myconf} --with-charset=latin1" 331 myconf="${myconf} --with-charset=latin1"
194 myconf="${myconf} --with-collation=latin1_swedish_ci" 332 myconf="${myconf} --with-collation=latin1_swedish_ci"
208 myconf="${myconf} $(use_with perl bench)" 346 myconf="${myconf} $(use_with perl bench)"
209 myconf="${myconf} --enable-assembler" 347 myconf="${myconf} --enable-assembler"
210 myconf="${myconf} --with-extra-tools" 348 myconf="${myconf} --with-extra-tools"
211 myconf="${myconf} --with-innodb" 349 myconf="${myconf} --with-innodb"
212 myconf="${myconf} --without-readline" 350 myconf="${myconf} --without-readline"
213 mysql_version_is_at_least "5.00.00.00" || myconf="${myconf} $(use_with raid)" 351 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
214 352
215 if useq "ssl" ; then 353 if useq "ssl" ; then
216 # --with-vio is not needed anymore, it's on by default and 354 # --with-vio is not needed anymore, it's on by default and
217 # has been removed from configure 355 # has been removed from configure
218 mysql_version_is_at_least "5.00.04.00" || myconf="${myconf} --with-vio" 356 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
219 if mysql_version_is_at_least "5.00.06.00" ; then 357 if mysql_version_is_at_least "5.0.6" ; then
220 # myconf="${myconf} --with-yassl" 358 # myconf="${myconf} --with-yassl"
221 myconf="${myconf} --with-openssl" 359 myconf="${myconf} --with-ssl"
222 else 360 else
223 myconf="${myconf} --with-openssl" 361 myconf="${myconf} --with-openssl"
224 fi 362 fi
225 else 363 else
226 myconf="${myconf} --without-openssl" 364 myconf="${myconf} --without-openssl"
238 else 376 else
239 myconf="${myconf} --without-berkeley-db" 377 myconf="${myconf} --without-berkeley-db"
240 fi 378 fi
241 fi 379 fi
242 380
243 if mysql_version_is_at_least "4.01.03.00" ; then 381 if mysql_version_is_at_least "4.1.3" ; then
244 myconf="${myconf} --with-geometry" 382 myconf="${myconf} --with-geometry"
245 myconf="${myconf} $(use_with cluster ndbcluster)" 383 myconf="${myconf} $(use_with cluster ndbcluster)"
246 fi 384 fi
247 385
248 if mysql_version_is_at_least "4.01.03.00" && useq "extraengine" ; then 386 if mysql_version_is_at_least "4.1.3" && useq "extraengine" ; then
249 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 387 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
250 myconf="${myconf} --with-archive-storage-engine" 388 myconf="${myconf} --with-archive-storage-engine"
251 389
252 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html 390 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
253 myconf="${myconf} --with-csv-storage-engine" 391 myconf="${myconf} --with-csv-storage-engine"
256 myconf="${myconf} --with-blackhole-storage-engine" 394 myconf="${myconf} --with-blackhole-storage-engine"
257 395
258 # http://dev.mysql.com/doc/mysql/en/federated-storage-engine.html 396 # http://dev.mysql.com/doc/mysql/en/federated-storage-engine.html
259 # http://dev.mysql.com/doc/mysql/en/federated-description.html 397 # http://dev.mysql.com/doc/mysql/en/federated-description.html
260 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html 398 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html
261 if mysql_version_is_at_least "5.00.03.00" ; then 399 if mysql_version_is_at_least "5.0.3" ; then
262 elog "Before using the Federated storage engine, please be sure to read" 400 elog "Before using the Federated storage engine, please be sure to read"
263 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html" 401 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html"
264 myconf="${myconf} --with-federated-storage-engine" 402 myconf="${myconf} --with-federated-storage-engine"
265 fi 403 fi
266 fi 404 fi
267 405
268 mysql_version_is_at_least "5.00.18.00" \ 406 mysql_version_is_at_least "5.0.18" \
269 && useq "max-idx-128" \ 407 && useq "max-idx-128" \
270 && myconf="${myconf} --with-max-indexes=128" 408 && myconf="${myconf} --with-max-indexes=128"
271} 409}
272 410
273configure_51() { 411configure_51() {
274 # TODO : !!!!! readd --withouth-readline 412 # TODO: !!!! readd --without-readline
275 # the failure depend upon config/ac-macros/readline.m4 checking into 413 # the failure depend upon config/ac-macros/readline.m4 checking into
276 # readline.h instead of history.h 414 # readline.h instead of history.h
277 myconf="${myconf} $(use_with ssl)" 415 myconf="${myconf} $(use_with ssl)"
278 myconf="${myconf} --enable-assembler" 416 myconf="${myconf} --enable-assembler"
279 myconf="${myconf} --with-geometry" 417 myconf="${myconf} --with-geometry"
286 # 5.1 introduces a new way to manage storage engines (plugins) 424 # 5.1 introduces a new way to manage storage engines (plugins)
287 # like configuration=none 425 # like configuration=none
288 local plugins="csv,myisam,myisammrg,heap" 426 local plugins="csv,myisam,myisammrg,heap"
289 if useq "extraengine" ; then 427 if useq "extraengine" ; then
290 # like configuration=max-no-ndb, archive and example removed in 5.1.11 428 # like configuration=max-no-ndb, archive and example removed in 5.1.11
291 plugins="${plugins},blackhole,federated,ftexample,partition" 429 plugins="${plugins},archive,blackhole,example,federated,partition"
292 430
293 elog "Before using the Federated storage engine, please be sure to read" 431 elog "Before using the Federated storage engine, please be sure to read"
294 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 432 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
295 fi 433 fi
296 434
302 if useq "cluster" ; then 440 if useq "cluster" ; then
303 plugins="${plugins},ndbcluster" 441 plugins="${plugins},ndbcluster"
304 myconf="${myconf} --with-ndb-binlog" 442 myconf="${myconf} --with-ndb-binlog"
305 fi 443 fi
306 444
445 if mysql_version_is_at_least "5.2" ; then
446 plugins="${plugins},falcon"
447 fi
448
307 myconf="${myconf} --with-plugins=${plugins}" 449 myconf="${myconf} --with-plugins=${plugins}"
450}
451
452pbxt_src_compile() {
453 mysql_init_vars
454
455 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
456
457 einfo "Reconfiguring dir '${PWD}'"
458 AT_GNUCONF_UPDATE="yes" eautoreconf
459
460 local myconf
461 myconf="${myconf} --with-mysql=${S}"
462 mkdir -p ${T}/lib
463 myconf="${myconf} --libdir=${D}/${MY_LIBDIR}"
464 useq "debug" && myconf="${myconf} --with-debug=full"
465 # TODO is safe/needed to use econf here ?
466 ./configure ${myconf} || die "problem configuring pbxt storage engine"
467 # TODO is safe/needed to use emake here ?
468 make || die "problem making pbxt storage engine (${myconf})"
469
470 popd
471 # TODO: modify test suite
472}
473
474pbxt_src_install() {
475 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
476 make install || die "failed pbxt install"
477 popd
308} 478}
309 479
310# 480#
311# EBUILD FUNCTIONS 481# EBUILD FUNCTIONS
312# 482#
313 483
314mysql_pkg_setup() { 484mysql_pkg_setup() {
315 enewgroup mysql 60 || die "problem adding 'mysql' group" 485 enewgroup mysql 60 || die "problem adding 'mysql' group"
316 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 486 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
317
318 if mysql_version_is_at_least "5.01.12.00" && useq "innodb" ; then
319 eerror "InnoDB now uses cmake to build, this is a TODO item, will be fixed shortly!"
320 die "InnoDB now uses cmake to build, this is a TODO item, will be fixed shortly!"
321 fi
322 487
323 # Check for USE flag problems in pkg_setup 488 # Check for USE flag problems in pkg_setup
324 if useq "static" && useq "ssl" ; then 489 if useq "static" && useq "ssl" ; then
325 eerror "MySQL does not support being built statically with SSL support enabled!" 490 eerror "MySQL does not support being built statically with SSL support enabled!"
326 die "MySQL does not support being built statically with SSL support enabled!" 491 die "MySQL does not support being built statically with SSL support enabled!"
327 fi 492 fi
328 493
329 if ! mysql_version_is_at_least "5.00.00.00" \ 494 if ! mysql_version_is_at_least "5.0" \
330 && useq "raid" \ 495 && useq "raid" \
331 && useq "static" ; then 496 && useq "static" ; then
332 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically" 497 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically"
333 eerror "with RAID support enabled." 498 eerror "with RAID support enabled."
334 die "USE flags 'raid' and 'static' conflict!" 499 die "USE flags 'raid' and 'static' conflict!"
335 fi 500 fi
336 501
337 if mysql_version_is_at_least "4.01.03.00" \ 502 if mysql_version_is_at_least "4.1.3" \
338 && ( useq "cluster" || useq "extraengine" ) \ 503 && ( useq "cluster" || useq "extraengine" ) \
339 && useq "minimal" ; then 504 && useq "minimal" ; then
340 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 505 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
341 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 506 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
342 fi 507 fi
343 508
509 mysql_check_version_range "4.0 to 5.0.99.99" \
510 && useq "berkdb" \
344 useq "berkdb" && elog "Berkeley DB support is deprecated and will be removed in future versions!" 511 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
345} 512}
346 513
347mysql_src_unpack() { 514mysql_src_unpack() {
348 # Initialize the proper variables first 515 # Initialize the proper variables first
349 mysql_init_vars 516 mysql_init_vars
350 517
351 unpack ${A} 518 unpack ${A}
352 519 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then
353 mv -f "${WORKDIR}/${MY_P}${MYSQL_RERELEASE}" "${S}" 520 if mysql_check_version_range "5.1 to 5.1.99" ; then
521 bitkeeper_fetch "mysql-5.1-ndb"
522 elif mysql_check_version_range "5.2.0 to 5.2.99" ; then
523 bitkeeper_fetch "mysql-5.2-falcon"
524 else
525 bitkeeper_fetch
526 fi
354 cd "${S}" 527 cd "${S}"
528 einfo "running upstream autorun on bk sources"
529 BUILD/autorun.sh
530 else
531 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}"
532 cd "${S}"
533 fi
355 534
356 # Apply the patches for this MySQL version 535 # Apply the patches for this MySQL version
357 if [[ -d "${WORKDIR}/${MY_FIXED_PV}" ]] ; then 536 EPATCH_SUFFIX="patch"
358 EPATCH_SOURCE="${WORKDIR}/${MY_FIXED_PV}" EPATCH_SUFFIX="patch" epatch 537 mkdir -p "${EPATCH_SOURCE}" || die "unable to create epatch directory"
359 fi 538 mysql_mv_patches
539 epatch || die "failed to apply all patches"
360 540
361 # Additional checks, remove bundled zlib 541 # Additional checks, remove bundled zlib
362 rm -f "${S}/zlib/"*.[ch] 542 rm -f "${S}/zlib/"*.[ch]
363 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 543 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
364 rm -f "scripts/mysqlbug" 544 rm -f "scripts/mysqlbug"
365 545
366 # Make charsets install in the right place 546 # Make charsets install in the right place
367 find . -name 'Makefile.am' \ 547 find . -name 'Makefile.am' \
368 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \; 548 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \;
369 549
370 # Manage mysqlmanager
371 mysql_version_is_at_least "5.00.15.00" \
372 && sed -i -e "s!@GENTOO_EXT@!!g" \
373 -e "s!@GENTOO_SOCK_PATH@!var/run/mysqld!g" \
374 "${S}/server-tools/instance-manager/Makefile.am"
375
376 if mysql_version_is_at_least "4.01.00.00" ; then 550 if mysql_version_is_at_least "4.1" ; then
377 # Remove what needs to be recreated, so we're sure it's actually done 551 # Remove what needs to be recreated, so we're sure it's actually done
378 find . -name Makefile \ 552 find . -name Makefile \
379 -o -name Makefile.in \ 553 -o -name Makefile.in \
380 -o -name configure \ 554 -o -name configure \
381 -exec rm -f {} \; 555 -exec rm -f {} \;
382 rm -f "ltmain.sh" 556 rm -f "ltmain.sh"
383 rm -f "scripts/mysqlbug" 557 rm -f "scripts/mysqlbug"
384 fi 558 fi
385 559
386 local rebuilddirlist bdbdir d 560 local rebuilddirlist d
387 561
388 if mysql_version_is_at_least "5.01.00.00" ; then 562 if mysql_version_is_at_least "5.1.12" ; then
389 rebuilddirlist=". storage/innobase" 563 rebuilddirlist="."
390 bdbdir='storage/bdb/dist' 564 # TODO IMPO! Check this with a cmake expert
565 useq "innodb" \
566 && cmake \
567 -DCMAKE_C_COMPILER=$(which $(tc-getCC)) \
568 -DCMAKE_CXX_COMPILER=$(which $(tc-getCC)) \
569 "storage/innobase"
391 else 570 else
392 rebuilddirlist=". innobase" 571 rebuilddirlist=". innobase"
393 bdbdir='bdb/dist'
394 fi 572 fi
395 573
396 for d in ${rebuilddirlist} ; do 574 for d in ${rebuilddirlist} ; do
397 einfo "Reconfiguring dir '${d}'" 575 einfo "Reconfiguring dir '${d}'"
398 pushd "${d}" &>/dev/null 576 pushd "${d}" &>/dev/null
399 AT_GNUCONF_UPDATE="yes" eautoreconf 577 AT_GNUCONF_UPDATE="yes" eautoreconf
400 popd &>/dev/null 578 popd &>/dev/null
401 done 579 done
402 580
403 # Berkeley DB has been removed in MySQL 5.1
404 if useq "berkdb" \
405 && mysql_check_version_range "4.01.00.00 to 5.00.99.99" ; then 581 if mysql_check_version_range "4.1 to 5.0.99.99" \
582 && useq "berkdb" ; then
406 [[ -w "${bdbdir}/ltmain.sh" ]] && cp -f "ltmain.sh" "${bdbdir}/ltmain.sh" 583 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh"
407 pushd "${bdbdir}" \ 584 pushd "bdb/dist" \
408 && sh s_all \ 585 && sh s_all \
409 || die "Failed bdb reconfigure" \ 586 || die "Failed bdb reconfigure" \
410 &>/dev/null 587 &>/dev/null
411 popd &>/dev/null 588 popd &>/dev/null
412 fi 589 fi
414 591
415mysql_src_compile() { 592mysql_src_compile() {
416 # Make sure the vars are correctly initialized 593 # Make sure the vars are correctly initialized
417 mysql_init_vars 594 mysql_init_vars
418 595
596 # $myconf is modified by the configure_* functions
419 local myconf 597 local myconf=""
420 598
421 if useq "static" ; then
422 myconf="${myconf} --with-mysqld-ldflags=-all-static"
423 myconf="${myconf} --with-client-ldflags=-all-static"
424 myconf="${myconf} --disable-shared"
425 else
426 myconf="${myconf} --enable-shared --enable-static"
427 fi
428
429 myconf="${myconf} --without-libwrap"
430
431 if useq "ssl" ; then 599 if useq "minimal" ; then
432 # --with-vio is not needed anymore, it's on by default and 600 configure_minimal
433 # has been removed from configure 601 else
434 mysql_version_is_at_least "5.00.04.00" || myconf="${myconf} --with-vio" 602 configure_common
435 if mysql_version_is_at_least "5.00.06.00" ; then 603 if mysql_version_is_at_least "5.1.10" ; then
436 # yassl-0.96 is still young and breaks with GCC-4.X or amd64 604 configure_51
437 # myconf="${myconf} --with-yassl"
438 myconf="${myconf} --with-openssl"
439 else 605 else
440 myconf="${myconf} --with-openssl" 606 configure_40_41_50
441 fi
442 else
443 myconf="${myconf} --without-openssl"
444 fi
445
446 if useq "debug" ; then
447 myconf="${myconf} --with-debug=full"
448 else
449 myconf="${myconf} --without-debug"
450
451 mysql_version_is_at_least "4.01.03.00" && useq "cluster" \
452 && myconf="${myconf} --without-ndb-debug"
453 fi
454
455 # These are things we exclude from a minimal build.
456 # Note that the server actually does get built and installed,
457 # but we then delete it.
458 local minimal_exclude_list="server embedded-server extra-tools innodb bench"
459
460 if ! useq "minimal" ; then
461 myconf="${myconf} --with-server"
462 myconf="${myconf} --with-extra-tools"
463
464 if ! mysql_version_is_at_least "5.00.00.00" ; then
465 if useq "raid" ; then
466 myconf="${myconf} --with-raid"
467 else
468 myconf="${myconf} --without-raid"
469 fi 607 fi
470 fi
471
472 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then
473 myconf="${myconf} --with-charset=utf8"
474 myconf="${myconf} --with-collation=utf8_general_ci"
475 else
476 myconf="${myconf} --with-charset=latin1"
477 myconf="${myconf} --with-collation=latin1_swedish_ci"
478 fi
479
480 # Optional again with MySQL 5.1
481 if mysql_version_is_at_least "5.01.00.00" ; then
482 if useq "innodb" ; then
483 myconf="${myconf} --with-innodb"
484 else
485 myconf="${myconf} --without-innodb"
486 fi
487 fi
488
489 # Lots of charsets
490 myconf="${myconf} --with-extra-charsets=all"
491
492 # The following fix is due to a bug with bdb on SPARC's. See:
493 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
494 # It comes down to non-64-bit safety problems.
495 if useq "sparc" || useq "alpha" || useq "hppa" || useq "mips" || useq "amd64" ; then
496 elog "Berkeley DB support was disabled due to incompatible arch"
497 myconf="${myconf} --without-berkeley-db"
498 else
499 # TODO: berkdb in MySQL 5.1 needs to be worked on
500 if useq "berkdb" && ! mysql_check_version_range "5.01.00.00 to 5.01.08.99" ; then
501 myconf="${myconf} --with-berkeley-db=./bdb"
502 else
503 myconf="${myconf} --without-berkeley-db"
504 fi
505 fi
506
507 if mysql_version_is_at_least "4.01.03.00" ; then
508 myconf="${myconf} --with-geometry"
509
510 if useq "cluster" ; then
511 myconf="${myconf} --with-ndbcluster"
512 else
513 myconf="${myconf} --without-ndbcluster"
514 fi
515 fi
516
517 if useq "big-tables" ; then
518 myconf="${myconf} --with-big-tables"
519 else
520 myconf="${myconf} --without-big-tables"
521 fi
522
523 mysql_version_is_at_least "5.01.06.00" \
524 && myconf="${myconf} --with-ndb-binlog"
525
526 if useq "embedded" ; then
527 myconf="${myconf} --with-embedded-privilege-control"
528 myconf="${myconf} --with-embedded-server"
529 else
530 myconf="${myconf} --without-embedded-privilege-control"
531 myconf="${myconf} --without-embedded-server"
532 fi
533
534 # Benchmarking stuff needs Perl
535 if useq "perl" ; then
536 myconf="${myconf} --with-bench"
537 else
538 myconf="${myconf} --without-bench"
539 fi
540 else
541 for i in ${minimal_exclude_list} ; do
542 myconf="${myconf} --without-${i}"
543 done
544 myconf="${myconf} --without-berkeley-db"
545 myconf="${myconf} --with-extra-charsets=none"
546 fi
547
548 if mysql_version_is_at_least "4.01.03.00" && useq "extraengine" ; then
549 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
550 myconf="${myconf} --with-archive-storage-engine"
551
552 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
553 myconf="${myconf} --with-csv-storage-engine"
554
555 # http://dev.mysql.com/doc/mysql/en/blackhole-storage-engine.html
556 myconf="${myconf} --with-blackhole-storage-engine"
557
558 # http://dev.mysql.com/doc/mysql/en/federated-storage-engine.html
559 # http://dev.mysql.com/doc/mysql/en/federated-description.html
560 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html
561 if mysql_version_is_at_least "5.00.03.00" ; then
562 elog "Before using the Federated storage engine, please be sure to read"
563 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html"
564 myconf="${myconf} --with-federated-storage-engine"
565 fi
566
567 # http://dev.mysql.com/doc/refman/5.1/en/partitioning-overview.html
568 if mysql_version_is_at_least "5.01.00.00" ; then
569 myconf="${myconf} --with-partition"
570 fi
571 fi
572
573 mysql_version_is_at_least "5.00.18.00" \
574 && useq "max-idx-128" \
575 && myconf="${myconf} --with-max-indexes=128"
576
577 mysql_version_is_at_least "5.01.05.00" \
578 && myconf="${myconf} --with-row-based-replication"
579
580 # TODO: Rechek again later, there were problems with assembler enabled
581 # and some combination of USE flags with MySQL 5.1
582 if mysql_check_version_range "5.01.00.00 to 5.01.08.99" ; then
583 myconf="${myconf} --disable-assembler"
584 else
585 myconf="${myconf} --enable-assembler"
586 fi 608 fi
587 609
588 # Bug #114895, bug #110149 610 # Bug #114895, bug #110149
589 filter-flags "-O" "-O[01]" 611 filter-flags "-O" "-O[01]"
590 612
591 # glib-2.3.2_pre fix, bug #16496 613 # glib-2.3.2_pre fix, bug #16496
592 append-flags "-DHAVE_ERRNO_AS_DEFINE=1" 614 append-flags "-DHAVE_ERRNO_AS_DEFINE=1"
593 615
594 append-flags "-fno-exceptions -fno-strict-aliasing" 616 CXXFLAGS="${CXXFLAGS} -fno-exceptions -fno-strict-aliasing"
595 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti" 617 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti"
596 mysql_version_is_at_least "5.00.00.00" \ 618 mysql_version_is_at_least "5.0" \
597 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 619 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
598 export CXXFLAGS 620 export CXXFLAGS
599 621
600 econf \ 622 econf \
623 --program-suffix="${MY_SUFFIX}" \
601 --libexecdir="/usr/sbin" \ 624 --libexecdir="/usr/sbin" \
602 --sysconfdir="${MY_SYSCONFDIR}" \ 625 --sysconfdir="${MY_SYSCONFDIR}" \
603 --localstatedir="${MY_LOCALSTATEDIR}" \ 626 --localstatedir="${MY_LOCALSTATEDIR}" \
604 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 627 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
605 --libdir="${MY_LIBDIR}" \ 628 --libdir="${MY_LIBDIR}" \
606 --includedir="${MY_INCLUDEDIR}" \ 629 --includedir="${MY_INCLUDEDIR}" \
607 --with-low-memory \ 630 --with-low-memory \
608 --enable-local-infile \
609 --with-mysqld-user=mysql \
610 --with-client-ldflags=-lstdc++ \ 631 --with-client-ldflags=-lstdc++ \
611 --enable-thread-safe-client \ 632 --enable-thread-safe-client \
612 --with-comment="Gentoo Linux ${PF}" \ 633 --with-comment="Gentoo Linux ${PF}" \
613 --with-unix-socket-path="/var/run/mysqld/mysqld.sock" \
614 --without-readline \
615 --without-docs \ 634 --without-docs \
616 ${myconf} || die "econf failed" 635 ${myconf} || die "econf failed"
617 636
618 # TODO: Move this before autoreconf !!! 637 # TODO: Move this before autoreconf !!!
619 find . -type f -name Makefile -print0 \ 638 find . -type f -name Makefile -print0 \
620 | xargs -0 -n100 sed -i \ 639 | xargs -0 -n100 sed -i \
621 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 640 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
622 641
623 emake || die "emake failed" 642 emake || die "emake failed"
643
644 mysql_version_is_at_least "5.1.1" && useq "pbxt" && pbxt_src_compile
624} 645}
625 646
626mysql_src_install() { 647mysql_src_install() {
627 # Make sure the vars are correctly initialized 648 # Make sure the vars are correctly initialized
628 mysql_init_vars 649 mysql_init_vars
629 650
630 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed" 651 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die
652
653 mysql_version_is_at_least "5.1.12" && useq "pbxt" && pbxt_src_install
631 654
632 insinto "${MY_INCLUDEDIR}" 655 insinto "${MY_INCLUDEDIR}"
633 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h 656 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h
634 657
635 # Convenience links 658 # Convenience links
636 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze" 659 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlanalyze${MY_SUFFIX}"
637 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair" 660 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlrepair${MY_SUFFIX}"
638 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize" 661 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqloptimize${MY_SUFFIX}"
639 662
640 # Various junk (my-*.cnf moved elsewhere) 663 # Various junk (my-*.cnf moved elsewhere)
641 rm -Rf "${D}/usr/share/info" 664 rm -Rf "${D}/usr/share/info"
642 for removeme in "mysql-log-rotate" mysql.server* \ 665 for removeme in "mysql-log-rotate" mysql.server* \
643 binary-configure* my-*.cnf mi_test_all* 666 binary-configure* my-*.cnf mi_test_all*
644 do 667 do
645 rm -f "${D}"/usr/share/mysql/${removeme} 668 rm -f "${D}"/usr/share/mysql/${removeme}
646 done 669 done
647 670
671 # TODO change at Makefile-am level
672 if [[ ${PN} == "mysql-slotted" ]] ; then
673 for moveme in "mysql_fix_privilege_tables.sql" \
674 "fill_help_tables.sql" "ndb-config-2-node.ini"
675 do
676 mv -f "${D}/usr/share/mysql/${moveme}" "${D}/usr/share/mysql${MY_SUFFIX}/" 2>/dev/null
677 done
678 fi
679
648 # Clean up stuff for a minimal build 680 # clean up stuff for a minimal build
649 if useq "minimal" ; then 681 if useq "minimal" ; then
650 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench} 682 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
651 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 683 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
652 rm -f "${D}/usr/sbin/mysqld" 684 rm -f "${D}/usr/sbin/mysqld"
653 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 685 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
654 fi 686 fi
655 687
688 if [[ ${PN} == "mysql-slotted" ]] ; then
689 local notcatched=$(ls "${D}/usr/share/mysql"/*)
690 if [[ -n "${notcatched}" ]] ; then
691 ewarn "QA notice"
692 ewarn "${notcatched} files in /usr/share/mysql"
693 ewarn "bug mysql-herd to manage them"
694 fi
695 rm -Rf "${D}/usr/share/mysql"
696 fi
697
656 # Configuration stuff 698 # Configuration stuff
657 if mysql_version_is_at_least "4.01.00.00" ; then 699 if mysql_version_is_at_least "4.1" ; then
658 mysql_mycnf_version="4.1" 700 mysql_mycnf_version="4.1"
659 else 701 else
660 mysql_mycnf_version="4.0" 702 mysql_mycnf_version="4.0"
661 fi 703 fi
662 insinto "${MY_SYSCONFDIR}" 704 insinto "${MY_SYSCONFDIR}"
663 doins "scripts/mysqlaccess.conf" 705 doins scripts/mysqlaccess.conf
706 sed -e "s!@MY_SUFFIX@!${MY_SUFFIX}!g" \
664 sed -e "s!@DATADIR@!${DATADIR}!g" \ 707 -e "s!@DATADIR@!${DATADIR}!g" \
665 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 708 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \
666 > "${TMPDIR}/my.cnf.ok" 709 > "${TMPDIR}/my.cnf.ok"
667 if mysql_version_is_at_least "4.01.00.00" && useq "latin1" ; then 710 if mysql_version_is_at_least "4.1" && useq "latin1" ; then
668 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 711 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok"
669 fi 712 fi
670 newins "${TMPDIR}/my.cnf.ok" my.cnf 713 newins "${TMPDIR}/my.cnf.ok" my.cnf
671
672 insinto "/etc/conf.d"
673 newins "${FILESDIR}/mysql.conf.d" "mysql"
674 mysql_version_is_at_least "5.00.11.00" \
675 && newins "${FILESDIR}/mysqlmanager.conf.d" "mysqlmanager"
676 714
677 # Minimal builds don't have the MySQL server 715 # Minimal builds don't have the MySQL server
678 if ! useq "minimal" ; then 716 if ! useq "minimal" ; then
679 exeinto "/etc/init.d"
680 newexe "${FILESDIR}/mysql.rc6" "mysql"
681 mysql_version_is_at_least "5.00.11.00" \
682 && newexe "${FILESDIR}/mysqlmanager.rc6" "mysqlmanager"
683
684 insinto "/etc/logrotate.d"
685 newins "${FILESDIR}/logrotate.mysql" "mysql"
686
687 # Empty directories ... 717 # Empty directories ...
688 diropts "-m0750" 718 diropts "-m0750"
689 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then 719 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then
690 dodir "${DATADIR}" 720 dodir "${DATADIR}"
691 keepdir "${DATADIR}" 721 keepdir "${DATADIR}"
718 for script in scripts/mysql* ; do 748 for script in scripts/mysql* ; do
719 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 749 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
720 done 750 done
721 fi 751 fi
722 752
723 ROOT="${D}" mysql_lib_symlinks 753 if [[ ${PN} == "mysql-slotted" ]] ; then
754 # MOVED HERE DUE TO BUG #121445
755 # create a list of files, to be used
756 # by external utilities
757 mkdir -p "${D}/var/lib/eselect/mysql/"
758 local filelist="${D}/var/lib/eselect/mysql/mysql${MY_SUFFIX}.filelist"
759 pushd "${D}/" &>/dev/null
760 find usr/bin/ usr/sbin/ \
761 -type f -name "*${MY_SUFFIX}*" \
762 -and -not -name "mysql_config${MY_SUFFIX}" \
763 > "${filelist}"
764 find usr/share/man \
765 -type f -name "*${MY_SUFFIX}*" \
766 | sed -e 's/$/.gz/' \
767 >> "${filelist}"
768 echo "${MY_SYSCONFDIR#"/"}" >> "${filelist}"
769 echo "${MY_LIBDIR#"/"}" >> "${filelist}"
770 echo "${MY_SHAREDSTATEDIR#"/"}" >> "${filelist}"
771 popd &>/dev/null
772 fi
773
774 mysql_lib_symlinks "${D}"
724} 775}
725 776
726mysql_pkg_preinst() { 777mysql_pkg_preinst() {
727 enewgroup mysql 60 || die "problem adding 'mysql' group" 778 enewgroup mysql 60 || die "problem adding 'mysql' group"
728 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 779 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
739 # Secure the logfiles 790 # Secure the logfiles
740 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err} 791 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
741 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql* 792 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
742 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql* 793 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
743 794
795 # Minimal builds don't have the MySQL server
744 if ! useq "minimal" ; then 796 if ! useq "minimal" ; then
745 # Your friendly public service announcement ... 797 docinto "support-files"
746 einfo 798 for script in \
747 elog "You might want to run:" 799 support-files/my-*.cnf \
748 elog "\"emerge --config =${CATEGORY}/${PF}\"" 800 support-files/magic \
749 elog "if this is a new install." 801 support-files/ndb-config-2-node.ini
750 einfo 802 do
751 mysql_version_is_at_least "5.01.00.00" \ 803 dodoc "${script}"
752 || elog "InnoDB is *not* optional as of MySQL-4.0.24, at the request of upstream." 804 done
805
806 docinto "scripts"
807 for script in scripts/mysql* ; do
808 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
809 done
753 fi 810 fi
811
812 einfo "you may want to read slotting upgrade documents in the overlay"
813 if useq "pbxt" && mysql_version_is_at_least "5.1" ; then
814 # TODO tell it better ;-)
815 einfo "mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
816 einfo "CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
817 einfo "if, after that you cannot start the mysql server"
818 einfo "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
819 einfo "use the mysql upgrade script to restore the table"
820 einfo " or "
821 einfo "CREATE TABLE IF NOT EXISTS plugin ("
822 einfo " name char(64) binary DEFAULT '' NOT NULL,"
823 einfo " dl char(128) DEFAULT '' NOT NULL,"
824 einfo " PRIMARY KEY (name)"
825 einfo ") CHARACTER SET utf8 COLLATE utf8_bin;"
826 fi
827 mysql_check_version_range "4.0 to 5.0.99.99" \
828 && useq "berkdb" \
754 useq "berkdb" && elog "Berkeley DB support is deprecated and will be removed in future versions!" 829 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
755} 830}
756 831
757mysql_pkg_config() { 832mysql_pkg_config() {
758 # Make sure the vars are correctly initialized 833 # Make sure the vars are correctly initialized
759 mysql_init_vars 834 mysql_init_vars
760 835
761 [[ -z "${DATADIR}" ]] && die "Sorry, unable to find DATADIR" 836 [[ -z "${DATADIR}" ]] && die "Sorry, unable to find DATADIR"
762 837
763 if built_with_use dev-db/mysql minimal ; then 838 if built_with_use ${CATEGORY}/${PN} minimal ; then
764 die "Minimal builds do NOT include the MySQL server" 839 die "Minimal builds do NOT include the MySQL server"
765 fi 840 fi
766 841
767 local pwd1="a" 842 local pwd1="a"
768 local pwd2="b" 843 local pwd2="b"
804 [[ -f "${ROOT}/${DATADIR}/mysql/user.frm" ]] \ 879 [[ -f "${ROOT}/${DATADIR}/mysql/user.frm" ]] \
805 || die "MySQL databases not installed" 880 || die "MySQL databases not installed"
806 chown -R mysql:mysql "${ROOT}/${DATADIR}" 2> /dev/null 881 chown -R mysql:mysql "${ROOT}/${DATADIR}" 2> /dev/null
807 chmod 0750 "${ROOT}/${DATADIR}" 2> /dev/null 882 chmod 0750 "${ROOT}/${DATADIR}" 2> /dev/null
808 883
809 if mysql_version_is_at_least "4.01.03.00" ; then 884 if mysql_version_is_at_least "4.1.3" ; then
810 options="--skip-ndbcluster" 885 options="--skip-ndbcluster"
811 886
812 # Filling timezones, see 887 # Filling timezones, see
813 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html 888 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html
814 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null 889 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null
863 wait %1 938 wait %1
864 einfo "Done" 939 einfo "Done"
865} 940}
866 941
867mysql_pkg_postrm() { 942mysql_pkg_postrm() {
943 if [[ ${PN} == "mysql-slotted" ]] ; then
868 mysql_lib_symlinks 944 mysql_lib_symlinks
945 mysql_clients_link_to_best_version
946 fi
869} 947}

Legend:
Removed from v.1.39  
changed lines
  Added in v.1.59

  ViewVC Help
Powered by ViewVC 1.1.20